/** \file Display.cpp
    \brief Abstart display interface.
*/

/* Copyright (C) 2008-2009 Tomasz Ostrowski <tomasz.o.ostrowski at gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.

 * Miniscope is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Display.h"

Display::Display(void)
{
	scope.fZoomX = 1.0;
	scope.fZoomY = 1.0;
	scope.fCursor1X = 0.0;
	scope.fCursor1Y = 0.0;
	scope.fCursor2X = 0.0;
	scope.fCursor2Y = 0.0;
	scope.fOffsetX = 0.0;
	scope.fOffsetY = 0.0;

	spectrum.fZoomX = 1.0;
	spectrum.fZoomY = 1.0;
	spectrum.fCursor1X = 0.0;
	spectrum.fCursor1Y = 0.0;
	spectrum.fCursor2X = 0.0;
	spectrum.fCursor2Y = 0.0;
	spectrum.fOffsetX = 0.0;
	spectrum.fOffsetY = 0.0;

	recorder.fZoomX = 1.0;
	recorder.fZoomY = 1.0;
	recorder.fCursor1X = 0.0;
	recorder.fCursor1Y = 0.0;
	recorder.fCursor2X = 0.0;
	recorder.fCursor2Y = 0.0;
	recorder.fOffsetX = 0.0;
	recorder.fOffsetY = 0.0;

	fRange = 1.0;
	fDivX = 1.0;
}

void Display::SetDiv(float fX)
{
	fDivX = fX;
}

void Display::SetVisibility(enum E_DISPLAY_MODE mode,
	bool bGridX, bool bGridY, bool bGridLabels)
{
	struct S_STATE& state = State(mode);
	state.bGridX = bGridX;
	state.bGridY = bGridY;
	state.bGridLabels = bGridLabels;
}

unsigned int Display::NearestPowerOfTwo(unsigned int count)
{
	unsigned int i = 1;
	while (i < count) {
		i = i << 1;
	}
	return i;
}
